#!/usr/local/bin/perl
require './setup.cgi';
require './readdata.pl';
require './headfoot.pl';
require './cookie.pl';

# NICOLE Board  [ Freeware ]
# fXNvg [ t[EFA ]
#
# Script written by NICOLE
# web-page : http://www10.big.or.jp/~nicole/
# e-mail   : nicole@big.or.jp
#
# Revision 1.80
# Modified by ЂƂ
# web-page : http://revision.s22.xrea.com/
# e-mail   : revision@s22.xrea.com
#---------------------------

@menuitems = ();
&SetDefaultConfig;
&Decode;
&GetCookie;

if (-e $file_config) {
	require './getconfig.pl';
	&ReadConfig($file_config);
	&ReadGreenName;
	&ReadSysop;
	&LanguageLoad;
} elsif ( 1 == $showBoardList ) {
	require './getconfig.pl';
	&ReadSysop;
	&LanguageLoad;
	require './selectboard.pl'; &SelectBoard;
	exit;
} else {
	&LanguageLoad;
	print "Content-type: text/html\n\n";
	print <<_HTML_;
<HTML>
<HEAD>
<TITLE>$label{'WELCOME_TITLE'}</TITLE>
<BODY>
$label{'WELCOME_INFO1'}<BR>
$label{'WELCOME_INFO2'}
</BODY></HTML>
_HTML_
	exit;
}

$chkview = time - $COOKIE{'lastview'};
if ( $chkview < $reload ) {
	&Error("<CENTER>$label{'ERROR_RELOAD'}</CENTER><P>");
}

@xman = ();
@ref = ();
if ( -e "$xfile" ){
	if ( open(FILE,"$xfile" ) ){
		while(<FILE>) { s/\r\n//g; s/\r|\n//g; push(@xman, $_); }
		close(FILE);
	}
} else {
	&CreateFile($xfile, 0606);
}
if ( -e "$xfile2" ){
	if ( open(FILE,"$xfile2" ) ){
		while(<FILE>) { s/\r\n//g; s/\r|\n//g; push(@ref, $_); }
		close(FILE);
	}
} else {
	&CreateFile($xfile2, 0606);
}
foreach(@xman){
	@xxman = split(/\./);
	@addr  = split(/\./, $ENV{'REMOTE_ADDR'});
	for ($i = 0; $i < 4; $i++) {
		$pos = index $xxman[$i], '*';
		if ($pos == 0) {
			$addr[$i] = '*';
		} elsif ( $pos > 0 ) {
			$buff = substr($addr[$i],0,$pos);
			$addr[$i] = $buff.'*';
		}
	}
	$xaddr = "$addr[0].$addr[1].$addr[2].$addr[3]";
	if ($xaddr eq $_) {
		&Error("$label{'ERROR_REMORT'} <B>$ENV{'REMOTE_HOST'} ( $ENV{'REMOTE_ADDR'} ) </B> <P>");
	}
}
$ok = 0;
$referer = "$ENV{'HTTP_REFERER'}";
$referer =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
foreach(@ref){
	if($referer !~ $_){ $ok = 1; } else { $ok = 0; last; }
}
if ( 1 == $ok ) { &Error("$label{'ERROR_REFERER'}"); }
@xword = ();
if ( -e "$word_file" ){
	if ( open(FILE,"$word_file" ) ){
		while(<FILE>) { s/\r\n//g; s/\r|\n//g; push(@xword, $_); }
		close(FILE);
	}
} else {
	&CreateFile($word_file, 0606);
}
if ( -e "$ulist" ){
	if ( open(FILE,"$ulist" ) ){
		while(<FILE>) { $buff = $_; }
		close(FILE);
		@uidlist = split(/:/, $buff);
	}
} else {
	&CreateUIDList;
}
if (1 == $config{'disable'} ){
	&Error("$label{'ERROR_CLOSED'}");
}
if ( 0 != open(FILE,"$file_menucolor") ){
	while(<FILE>) {
		chop;
		my($a,$b) = split(/<>/);
		$menu_color_list{$a} = $b;
		push(@menu_col_array,"$a:$b");
	}
}
close(FILE);

&ReadData;

if ( $kindselect ne '' ) {
	$kindmenu = $kindselect;
} else {
	if ($COOKIE{'kindselect'} eq '' ) {
		$COOKIE{'kindselect'} = "IȊO";
	}
	$kindmenu = $COOKIE{'kindselect'};
}

if ( $finselect ne '' ) {
	$fincheck = $finselect;
} else {
	if ($COOKIE{'finselect'} eq '' ) {
		$COOKIE{'finselect'} = "off";
	}
	$fincheck = $COOKIE{'finselect'};
}

if ( $COOKIE{'disp'} eq '' || $config{'show_topiclist'} == 0 ) { $COOKIE{'disp'} = '0'; }

if ( $cmd eq 'new')		{	require './inputmsg.pl';	&InputMessage('new');
} elsif ( $cmd eq 'reply')	{	require './inputmsg.pl';	&InputMessage('reply');
} elsif ( $cmd eq 'edit') 	{	require './inputmsg.pl';	&InputMessage('edit');
} elsif ( $cmd eq 'regist')	{	require './regist.pl';		&RegistMessage;
} elsif ( $cmd eq 'delete')	{ 	require './deletedata.pl';	&DeleteMessage( $wparam );
} elsif ( $cmd eq 'fin')	{ 	require './finish.pl';		&FinishMessage( $wparam );
} elsif ( $cmd eq 'revive')	{ 	require './finish.pl';		&ReviveMessage( $wparam );
} elsif ( $cmd eq 'search' && $wparam ne '')	{
					$COOKIE{'finselect'} = $fincheck;
					$COOKIE{'kindselect'} = $kindmenu;
					require './search.pl'; &Search( $wparam );
} elsif ( $cmd eq 'topic')	{	&DrawHeader('',0,0);
					require './drawtopic.pl';	&DrawTopic($wparam,1);
} elsif ( $cmd eq 'sort0')  	{	$COOKIE{'sort'} = '0'; require './view.pl'; &View($COOKIE{'disp'});
} elsif ( $cmd eq 'sort1')  	{	$COOKIE{'sort'} = '1'; require './view.pl'; &View($COOKIE{'disp'});
} elsif ( $cmd eq 'disp0')  	{	$COOKIE{'disp'} = '0'; require './view.pl'; &View($COOKIE{'disp'});
} elsif ( $cmd eq 'disp1')  	{	$COOKIE{'disp'} = '1'; require './view.pl'; &View($COOKIE{'disp'});
} elsif ( $cmd eq 'last')  	{	$INFO_COOKIE{'reply'} = $lparam;  &SetCookie;
					&DrawHeader('',0,0);
					require './drawtopic.pl';	&DrawTopic($wparam,1);
} else {
					$COOKIE{'finselect'} = $fincheck;
					$COOKIE{'kindselect'} = $kindmenu;
					require './view.pl'; &View($COOKIE{'disp'});
}
&DrawFooter(0);
exit;

#---------------------------
# DECODE

sub Decode {
	my($buf);

	if ($ENV{'REQUEST_METHOD'} eq "$method") { 
		if($ENV{'CONTENT_LENGTH'} > $max_comment*2){
			&Error("$label{'ERROR_LENGTH'}");
		}
		read(STDIN, $buf , $ENV{'CONTENT_LENGTH'});
	} else {
		$buf  = $ENV{'QUERY_STRING'};
	}

	@pairs = split(/&/,$buf);

	foreach $pair (@pairs) {
		my($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		&jcode'convert(*value,'sjis');
		&jcode'h2z_sjis(*value);
		$value =~ s/\&/\&amp;/g;
		$value =~ s/\"/\&quot;/g;
		$value =~ s/</\&lt;/g;
		$value =~ s/>/\&gt;/g;    
		$FORM{$name} = "\0" if (defined($FORM{$name}));
		$FORM{$name} = $value;
	}

	$name = $FORM{'name'};
	$name =~ s/\r\n/\n/g;
	$name =~ s/\r|\n//g;

	$subject = $FORM{'subject'};
	$subject =~ s/\r\n/\n/g;
	$subject =~ s/\r|\n//g;

	$email = $FORM{'email'};
	$email =~ s/\r\n/\n/g;
	$email =~ s/\r|\n//g;

	$hp = $FORM{'hp'};
	$hp =~ s/\r\n/\n/g;
	$hp =~ s/\r|\n//g;

	$icq = $FORM{'icq'};
	$icq =~ s/\r\n/\n/g;
	$icq =~ s/\r|\n//g;

	$comment = $FORM{'comment'};
	$comment =~ s/\r\n/\n/g;
	$comment =~ s/\r|\n/<BR>/g;

	$password = $FORM{'password'};
	$password =~ s/\r\n//g;
	$password =~ s/\r|\n//g;

	$menu = $FORM{'menu'};
	$menu =~ s/\r\n//g;
	$menu =~ s/\r|\n//g;

	$pwd = $FORM{'pwd'};
	$pwd =~ s/\r\n//g;
	$pwd =~ s/\r|\n//g;

	$sysop_id = $FORM{'sysop_id'};
	$sysop_id =~ s/\r\n//g;
	$sysop_id =~ s/\r|\n//g;

	$number = $FORM{'number'};

	$ip = $FORM{'ip'};
	$remote_host = $FORM{'remote_host'};
	$reply = $FORM{'reply'};
	$reply_count = $FORM{'reply_count'};
	if ($FORM{'reply_time'}) { $reply_time = $FORM{'reply_time'}} else { $reply_time = time };
	$time = $FORM{'time'};
	$cmd = $FORM{'cmd'};
	$wparam = $FORM{'wparam'};
	$lparam = $FORM{'lparam'};

	if ($FORM{'page'}) { $page = $FORM{'page'}; } else { $page = 0; };
	if ($FORM{'board'}) { $board = $FORM{'board'}; };

	$file_data  = "$dat_dir/$board.log";
	$file_config = "$dat_dir/$board.cfg";
	$file_counter = "$dat_dir/uidmax.cnt";

	$kindselect = $FORM{'kindselect'};
	$finselect = $FORM{'finselect'};

	if($ENV{"QUERY_STRING"}=~/point=([^\&]*)/) {
		require './board_incm.pl'; &INCM_Output($1);
	}
}

sub my_flock {
	my %lfh = (dir => './lockdir/', basename => 'lockfile', timeout => 60, trytime => 10, @_);

	$lfh{path} = $lfh{dir} . $lfh{basename};

	unless ( -d $lfh{dir} ) {
		mkdir($lfh{dir},0777) or &Error("$label{'ERROR_LOCKDIR'}");
	}
	if ( ! -e "$lfh{path}" ) {
		&CreateFile($lfh{path}, 0666);
	}

	for (my $i = 0; $i < $lfh{trytime}; $i++, sleep 1) {
		return \%lfh if (rename($lfh{path}, $lfh{current} = $lfh{path} . time));
	}
	opendir(LOCKDIR, $lfh{dir});
	my @filelist = readdir(LOCKDIR);
	closedir(LOCKDIR);
	foreach (@filelist) {
		if (/^$lfh{basename}(\d+)/) {
			return \%lfh if (time - $1 > $lfh{timeout} and rename($lfh{dir} . $_, $lfh{current} = $lfh{path} . time));
			last;
		}
	}
	undef;
}

sub my_funlock {
	rename($_[0]->{current}, $_[0]->{path});
}

sub lock_error {
	&Error("$label{'ERROR_LOCK'}");
}

#---------------------------
# ERROR

sub Error {
	my($errmsg) = @_;
	&DrawHeader("$label{'ERROR_HEADDER'}",1,1);
	$html .= "$errmsg\n";
	&DrawFooter(0);
	exit 0;
}

#---------------------------
# FORMAR DATE TIME

sub FormatDateTime {
	my($atime, $flag) = @_;
	$ENV{'TZ'} = "JST-9";
	my($sec,$min,$hour,$mday,$mon,$year,$dayofweek) = gmtime($atime+$timezone*60*60);

	if ($year < 99) { $year += 100; }
	$year += 1900;
	$mon++;
	if ($mon < 10) { $mon = "0$mon";}
	if ($mday < 10) { $mday = "0$mday";}
	if ($hour < 10) { $hour = "0$hour";}
	if ($min < 10) { $min = "0$min";}
	$dow = ($label{'WEEK_SUN'},$label{'WEEK_MON'},$label{'WEEK_TUE'},$label{'WEEK_WED'},$label{'WEEK_THU'},$label{'WEEK_FRI'},$label{'WEEK_SAT'}) [$dayofweek];

	if (1 == $flag) {
		$date = "$mon/$mday ($dow) $hour:$min";
	} else {
		$date = "$year/$mon/$mday ($dow) $hour:$min";
	}

	$date;
}

#---------------------------
# FORMAT NAME

sub FormatName {
	my($name) = @_;
	my($shougou,$dummy);

	if ( $name eq $admin_name ) {
		$name = "<FONT class='adm'><B>$name</B> [$label{'ADMIN_LABEL'}]</FONT>";
	}
	
	$dummy = &SysopCheck($name);
	if ( $dummy ne '' ) {
		$name = "<FONT class='sysop'><B>$name</B> [$label{'SYSOP_LABEL'}]</FONT>";
	} else {
		$dummy = &FixCheck($name);
		if ( $dummy ne '' ) {
			$name = "<FONT class='grn'><B>$name</B></FONT>";
		}
	}
	$name;
}

#---------------------------
# ͓URLFTPpȂǂϊ

sub	FormatComment {
	my($com,$name)=@_;

	$com = "<P>$com</P>";
	$com =~ s/>(&gt;[^<]*)/><FONT COLOR=$config{'color_quote'}>$1<\/FONT>/g;
	$com =~ s/(http:\/\/[0-9a-z?#=:\.\~\-\_\/\&\;]+)/<A HREF='$1' TARGET='_blank'>$1<\/A>/ig;
	$com =~ s/(ftp:\/\/[0-9a-z\.\~\-\_\/]+)/<A HREF='$1' TARGET='_blank'>$1<\/A>/ig;
	if ( $name eq $admin_name ) {
		$com =~ s/(&lt;B&gt;)/<B>/ig;
		$com =~ s/(&lt;\/B&gt;)/<\/B>/ig;
		$com =~ s/(&lt;U&gt;)/<U>/ig;
		$com =~ s/(&lt;\/U&gt;)/<\/U>/ig;
		$com =~ s/(&lt;UL&gt;)/<UL>/ig;
		$com =~ s/(&lt;\/UL&gt;)/<\/UL>/ig;
		$com =~ s/(&lt;LI&gt;)/<LI>/ig;
		$com =~ s/(&lt;\/LI&gt;)/<\/LI>/ig;
		$com =~ s/(&lt;EM&gt;)/<EM>/ig;
		$com =~ s/(&lt;\/EM&gt;)/<\/EM>/ig;
	}

	$com;
}

#---------------------------
# GET DATA

sub GetData {
	my($num) = @_;
	($number,$reply,$reply_count,$reply_time,$time,$subject,$name,$email,$hp,$icq,$ip,$password,$comment,$menu,$remote_host,$flag_fin,$uid) = split(/<>/,$datalist{$num});
}

#---------------------------
# SET DATA

sub SetData {
	my($num) = @_;
	if($reply_count eq '') { $reply_count = 0 };
	if ($name eq $admin_name){
		$ip = '';
		$remote_host = '';
	}
	$datalist{$num} = "$number<>$reply<>$reply_count<>$reply_time<>$time<>$subject<>$name<>$email<>$hp<>$icq<>$ip<>$password<>$comment<>$menu<>$remote_host<>$flag_fin<>$uid<>0";
}

#---------------------------
# IS NEW

sub IsNew {
	my($t) = @_;
	my($icon) = '';

	if ( int((time - $t)/3600) < $config{'flush_time'}) {
		$icon = "<IMG SRC='$icon_new' WIDTH=$icon_new_width HEIGHT=$icon_new_height BORDER=0 ALT='New'>";
	}
	return $icon;
}

#---------------------------
# IS SORT

sub IsSort {
	return ( $cmd eq 'sort1' || $COOKIE{'sort'} eq '1');
}

#---------------------------
# IS KIND

sub IsKind {
	$kindmenu = $COOKIE{'kindselect'};
}

#---------------------------
# IS FIN

sub IsFin {
	$fincheck = $COOKIE{'finselect'};
}

#---------------------------
# IS TRIM DATA

sub TrimData {
	my($str) = @_;
	my($trimstr);

	$trimstr = $str;
	$trimstr =~ s/ //g;
	$trimstr =~ s/@//g;
	return $trimstr;
}

#---------------------------
# CREATE FILE

sub CreateFile {
	my($filename,$attr) = @_;

	open(FILE,">$filename");
	close(FILE);
	chmod( $attr , $filename);
}

#---------------------------
# FIX CHECK

sub	FixCheck {
	my($fname) = @_;
	my($aname, $avalue);
	my($ret) = "";

	foreach (@fix_data) {
		($aname,$avalue) = split(/<>/);
		if( $aname eq $fname ){
			$ret = $avalue; last;
		}
	}
	return $ret;
}

#---------------------------
# SYSOP CHECK

sub	SysopCheck {
	my($fname) = @_;
	my($aname, $avalue, $arank);
	my($ret) = "";

	foreach (@sysop_data) {
		($aname,$avalue,$arank) = split(/<>/);
		if( $aname eq $fname ){
			$ret = $avalue . ":" . $arank; last;
		}
	}
	return $ret;
}

#---------------------------
# LANGUAGE LOAD

sub	LanguageLoad {
	if ( $ENV{'HTTP_ACCEPT_LANGUAGE'} ne '' ) {
		@language = split(/,/,$ENV{'HTTP_ACCEPT_LANGUAGE'});
		$pos = index $language[0],";";
		if ($pos >= 0) {
			$lng = substr($language[0],0,$pos);
		} else {
			$lng = $language[0];
		}
		$lng_file = "label_$lng.pl";
		if ( ! -e "../$lng_file" ) {
			$lng_file = "label_$def_language.pl";
		}
	} else {
		$lng_file = "label_$def_language.pl";
	}
	require "../$lng_file";
}

#---------------------------
# Create UID List

sub CreateUIDList {
	my(@basedata) = ();
	srand(time);
	@basedata = split(/:/, "0:1:2:3:4:5:6:7:8:9:a:b:c:d:e:f:g:h:i:j:k:l:m:n:o:p:q:r:s:t:u:v:w:x:y:z:A:B:C:D:E:F:G:H:I:J:K:L:M:N:O:P:Q:R:S:T:U:V:W:X:Y:Z:/:+");
	while(@basedata) {
		push(@uidlist, splice(@basedata, rand(@basedata), 1));
	}
	open(FILE,">$ulist");
	foreach(@uidlist) {
		print FILE "$_:";
	}
	close(FILE);
	chmod( 0755 , $ulist);
	return $uidlist;
}

__END__
