#---------------------------
# GET COOKIE

sub GetCookie{
	my($name,$value);
	my($c_id);

	%DUMMY = &GetCookie2;

	foreach $pair (split(/>/, $DUMMY{$cookie_id})) {
		($name,$value) = split(/</,$pair);
		$COOKIE{$name} = $value;
	}

	$uid = $COOKIE{'uid'};

	$c_id = $cookie_id2 . $board;
	@pairs = split(/>/,$DUMMY{$c_id});
	foreach $pair (@pairs) {
		my($name,$value) = split(/</, $pair);
		if ( $name eq "kindselect" || $name eq "finselect" || $name eq "disp" ) {
			$COOKIE{$name} = $value;
		} else {
			$INFO_COOKIE{$name} = $value;
		}
	}
}

#---------------------------
# SET COOKIE

sub SetCookie {
	my($lastview);
	$lastview = time;
	$COOKIE{'lastview'} = $lastview;

	my($cook) = "name<$COOKIE{'name'}>hp<$COOKIE{'hp'}>email<$COOKIE{'email'}>icq<$COOKIE{'icq'}>password<$COOKIE{'password'}>sort<$COOKIE{'sort'}>uid<$COOKIE{'uid'}>lastview<$COOKIE{'lastview'}>";
	my($cook1) = "kindselect<$COOKIE{'kindselect'}>finselect<$COOKIE{'finselect'}>disp<$COOKIE{'disp'}>";
	my($cook2) = "last<$INFO_COOKIE{'last'}>reply<$INFO_COOKIE{'reply'}>";
	my($c_id);
	my($c_id2);

	$c_id = $cookie_id2 . $board;

	$ENV{'TZ'} = "GMT";

	my($buf);
	$buf = &SetCookie2($cookie_id,$cook);
	print "$buf\n";
	if ( $easy_info == 1 ) {
		$buf = &SetCookie2($c_id,$cook1.$cook2);
		print "$buf\n";
	} else {
		$buf = &SetCookie2($c_id,$cook1);
		print "$buf\n";
	}
}

#---------------------------
# SET COOKIE2(URL Encode)

sub SetCookie2 {
	my($CookieName, $CookieValue, $Domain, $Path) = @_;

	$CookieValue =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
	$CookieValue =~ tr/ /+/;

	my($CookieHeaderString);
	$CookieHeaderString .= "Set-Cookie: $CookieName=$CookieValue\;";

	$ENV{'TZ'} = "GMT";

	my($sec,$min,$hour,$mday,$mon,$year,$wday) = localtime(time + 7*24*60*60);
	if ($year < 99) { $year += 100; }
	$year += 1900;
	if ($sec  < 10)  { $sec  = "0$sec";  }
	if ($min  < 10)  { $min  = "0$min";  }
	if ($hour < 10)  { $hour = "0$hour"; }
	if ($mday < 10)  { $mday = "0$mday"; }
	$mon = ('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec')[$mon];
	$youbi = ('Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday')[$wday];
	$CookieHeaderString .= " expires=$youbi, $mday\-$mon\-$year $hour:$min:$sec GMT";

	if($Domain) {
		$CookieHeaderString .= " domain=$Domain;";
	}
	if($Path) {
		$CookieHeaderString .= " path=$Path;";
	}
	return $CookieHeaderString;
}

#---------------------------
# GET COOKIE2(URL Decode)

sub GetCookie2 {
	my(@CookieList) = split(/\; /, $ENV{'HTTP_COOKIE'});
	my(%Cookie2) = ();
	my($key, $CookieName, $CookieValue);
	for $key (@CookieList) {
		($CookieName, $CookieValue) = split(/=/, $key);
		$CookieValue =~ s/\+/ /g;
		$CookieValue =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
		$Cookie2{$CookieName} = $CookieValue;
	}
	return %Cookie2;
}

1;

