

#---------------------------
# READ CONFIG

sub ReadConfig {
	my($filename) = @_;
	my($name,$value);
	open(FILE,"$filename") || &Error ("can't open $filename");
	while(<FILE>){
		chop;
		($name,$value) = split(/<>/);
		$config{ $name } = $value;
	}
	close(FILE);

	$config{'information'} =~ s/(&lt;)/</ig;
	$config{'information'} =~ s/(&gt;)/>/ig;
	$config{'information'} =~ s/(&quot;)/"/ig;
	@menuitems = ();
	if (1 == $config{'menu_use'}){
		@pairs = split(/<BR>/,$config{'menu_list'});
		foreach (@pairs) {
			push( @menuitems, $_ );
		}
	}
}

#---------------------------
# READ GREEN NAME DATA

sub ReadGreenName {
	@fix_data = ();
	open(INPUT,"$fixname_file") || &Error ("can't open $fixname_file");
	while(<INPUT>){
		chop;
		push(@fix_data, $_);
	}
	close(INPUT);
}

#---------------------------
# READ SYSOP DATA

sub ReadSysop {
	@sysop_data = ();
	if( -e "$sysop_file" ) {
		open(INPUT,"$sysop_file") || &Error ("can't open $sysop_file");
		while(<INPUT>){
			chop;
			push(@sysop_data, $_);
		}
		close(INPUT);
	}
}

1;
