
#---------------------------
# MAIL SEND

sub MailSend {
	my($mail_add) = @_;
	my($msubject,$mheadder,$mbody,$mdate,$err);

	$mdate = &FormatDateTime($reply_time, 1);
	&jcode'h2z_sjis(*comment);
	$comment =~ s/<BR>/\n/g;
	$comment =~ s/\&amp;/\&/g;
	$comment =~ s/\&quot;/\"/g;
	$comment =~ s/\&lt;/</g;
	$comment =~ s/\&gt;/>/g;    

	$msubject = "$label{'MAIL_SUBJECT'}";
	$mheadder  = "From: $admin_email\nTo: $mail_add\nSubject: $msubject\n";
	$mheadder .= "Mime-Version: 1.0\n";
	$mheadder .= "Content-Type: text/plain; charset=$label{'MAIL_CHARSET'}\n";
	$mheadder .= "Content-Transfer-Encoding: 7bit\n\n";
	$mbody = '';

	$mbody .= "$label{'MAIL_POSTDATE'}$mdate\n";
	$mbody .= "$label{'MAIL_NAME'}$name\n";
	$mbody .= "$label{'MAIL_EMAIL'}$email\n";
	$mbody .= "$label{'MAIL_HOMEPAGE'}$hp\n";
	$mbody .= "$label{'MAIL_ICQ'}$icq\n";
	$mbody .= $comment;

	&jcode'convert(*mheadder, "jis");
	&jcode'convert(*mbody, "jis");
	$err = 0;
	open(MAIL, "| $config{'sendmail_path'} -t -f'$admin_email'") or $err = 1;
	if ($err == 0){
		print MAIL $mheadder;
		print MAIL $mbody;
		print MAIL "\n";
		print MAIL "\n\n" . "." . "\n";
		close(MAIL);
	} else {
		&Error("$label{'ERROR_MAIL'}");
	}
}

1;
