

#---------------------------
# READ DATA

sub ReadData {
	my($number,$reply);
	my($lockhandle);

	$max_number = 0;
	$uid_number = 0;
	@topiclist = ();
	@replylist = ();

	unless (-e "$file_data") {
		open(FILE,">$file_data") || &Error ("can't open $file_data");
		close(FILE);
		chmod( 0666, $file_data );
	} else {
		$lockhandle = &my_flock(basename => "$board") or lock_error();
		open(FILE,"$file_data") || &Error ("can't open $file_data");
		while(<FILE>){
			chop;
			($number,$reply) = split(/<>/);
			$datalist{$number} = $_;
			if ( $max_number < $number ) { $max_number = $number; }
			if ( $reply ne '') {
				push( @replylist, $number);
			} else {
				push( @topiclist, $number );
			}
		}
		close(FILE);
		&my_funlock($lockhandle);
		@replylist = reverse(@replylist);

		$lockhandle = &my_flock() or lock_error();
		open(FILE,"$file_counter") || &Error ("can't open $file_counter");
		$uid_number = <FILE>;
		close(FILE);
		&my_funlock($lockhandle);

	}
}

1;
