

#---------------------------
# View

sub View {
	my($mode) = @_;
	my($cnt) = @topiclist;

	&SetCookie;
	&IsKind;
	&IsFin;
	&DrawHeader('',0,0);
	if (0 == $cnt){
		$html .= "<HR NOSHADE SIZE=1><CENTER><EM>$label{'NO_THEREAD'}</EM></CENTER>";
	} else {
		require './sorttopic.pl';
		&SortTopics;
		if (1 == $config{'show_topiclist'}){
			&DrawNavi;
			&ViewList($mode);
		}
		if ( $mode == 0 ) { &ViewDump; }
		&DrawNavi;
	}
}

#---------------------------
# View LIST

sub ViewList {
	my($mode) = @_;
	my($i,$n,$atime,$aname,$icon,$replyicon,$href,$atimecolor,$areply);

	$html .= "<A NAME='list'></A>\n";
	$html .= "<TABLE class='sub'><TR><TD>\n";
	$html .= "<TABLE class='bgc'>\n";
	$html .= "<TR>";
	if ( 1 == $config{'menu_use'} ){
		$html .= "<TD NOWRAP WIDTH=5% class='sub'>$config{'menu_name'}</TD>";
	}
	$html .= "<TD NOWRAP WIDTH=50% class='sub'>$label{'TITLE_TITLE'}</TD>\n";
	if ( 1 != $config{'readonly'} ){
		$html .= "<TD NOWRAP WIDTH=20% class='sub'>$label{'TITLE_CONTRIBUTOR'}</TD>";
		$html .= "<TD NOWRAP WIDTH=5% class='sub'>$label{'TITLE_RESPONSE'}</TD>";
	} else {
		$html .= "<TD NOWRAP WIDTH=5% class='sub'>$label{'TITLE_POSTSCRIPT'}</TD>";
	}
	$html .= "<TD NOWRAP WIDTH=5% class='sub'>$label{'TITLE_UPDATE'}</TD>";

	&GetData( $max_number );
	$areply = $reply;

	for($i = $page*$config{'viewcount'}; $i < $page*$config{'viewcount'}+$config{'viewcount'}; $i++){
		if($topiclist[$i]){

			&GetData( $topiclist[$i] );
			if (0 != $number){
				$atime = &FormatDateTime($reply_time, 1);
				$aname = &FormatName($name);
				$icon = &IsNew( $time );
				$replyicon = &IsNew( $reply_time );
				if ( 0 == $reply_count ) { $replyicon = ''; }

				if ( $number == $max_number || $number == $areply){
					$atimecolor = $config{'color_em'};
				} else {
					$atimecolor = $config{'color_text'};
				}

				if ( $mode == 0 ) {
					$href = "<A HREF='#topic$number'>";
				} else {
					$href = "<A HREF='$cgi_path$cgi?board=$board&cmd=topic&wparam=$number'>";
				}

				$html .= "<TR>";

				if ( 0 != $flag_fin ) {
					if ( 1 == $config{'menu_use'} ){
						$html .= "<TD NOWRAP class='fin'>$menu</TD>";
					}

					$html .= "<TD class='fin'>$href$icon =$label{'HEADDER_KIND1_END'}= <strike>$subject</strike></A></TD>";
				} else {
					if ( 1 == $config{'menu_use'} ){
						$html .= "<TD NOWRAP class='cmttxt'>$menu</TD>";
					}

					$html .= "<TD class='cmtlnk'>$href$icon $subject</A></TD>";
				}
				
				if ( 1 != $config{'readonly'} ){
					$html .= "<TD class='cmttxt'>$href$aname</A></TD>";
				}
				$html .= "<TD class='cmttxt' NOWRAP>$reply_count $replyicon</TD>";
				$html .= "<TD class='cmttxt' NOWRAP><FONT COLOR=$atimecolor>$atime</FONT></TD>";

				$html .= "</TR>\n";
			}
		}
	}
	$html .= "</TR></TABLE>\n";
	$html .= "</TD></TR></TABLE><BR>\n";

}

#---------------------------
# View DUMP

sub	ViewDump {
	my($i);

	$i = @topiclist;
	if (0 != $i){
		for($i = $page*$config{'viewcount'}; $i < $page*$config{'viewcount'}+$config{'viewcount'}; $i++){
			if($topiclist[$i]){
				$nowpage=$i;
				require './drawtopic.pl';
				&DrawTopic( $topiclist[$i], 1);
			}
		}
	}
}

#---------------------------
# DRAW NAVI

sub	DrawNavi {
	my($cpage,$mpage,$npage,$bpage,$maxpage,$s,$n,$dn);
	my($start,$buf);
	my($bgroup,$agroup,$t_count,$t_list);

	$t_count = @topiclist;
	$t_list = 1;
	if ( $config{'max_topic'} < $t_count ) { $t_list++; }

	$npage = $page+1;
	$mpage = int((@topiclist-$t_list)/$config{'viewcount'}) +1;

	&IsKind;

	if ( &IsSort ) {
		$s = " [ $label{'HEADDER_RESPONSE'} ]";
	}

	$html .= "<TABLE WIDTH=100% BORDER=0 CELLPADDING=0 CELLSPACING=0>\n";
	$html .= "<TR><TD><B>$config{'bbstitle'}</B> $s</TD><TD ALIGN=right NOWRAP>";

	$start = int($page/$disppage)*$disppage;
	$buf = $start+($disppage-1);
	$maxpage = $mpage-1;

	$html .= "Page : ";
	if($page >= 1) {
		$cpage = $page - 1;
		$html .= "<A HREF=\"$cgi?board=$board&page=$cpage\">$label{'HEADDER_BEFORE_PAGE'}</A>&nbsp; ";
	}
	if ( $start >= $disppage ) {
		$bpage = $start-1;
		$bgroup = $start+1;
		if ( $bgroup > $disppage ) { $bgroup = $disppage; }
		$html .= "<A title=\"$label{'HEADDER_FIRST_PAGE'}\" HREF='$cgi_path$cgi?board=$board&page=0'>&lt;&lt;</A>&nbsp; <A HREF='$cgi_path$cgi?board=$board&page=$bpage'>&lt;-$bgroup</A>&nbsp; ";
	}
	for ( $n=$start; $n<$mpage; $n++ ){
		$dn = $n+1;
		if ( $n > $buf ) {
			$agroup = $mpage - $n;
			if ( $agroup > $disppage ) { $agroup = $disppage; }
			$html .= "&nbsp; <A HREF='$cgi_path$cgi?board=$board&page=$n'>$agroup+&gt;</A>&nbsp; <A title=\"$label{'HEADDER_LAST_PAGE'}\" HREF='$cgi_path$cgi?board=$board&page=$maxpage'>&gt;&gt;</A>";
			last;
		}

		if ( $page == $n ) {
			$html .= "<b>[$dn]</b> ";
		} else {
			$html .= "<A HREF='$cgi_path$cgi?board=$board&page=$n'>$dn</A> ";
		}
	}
	if ($mpage > $npage){
		$html .= "&nbsp; <A HREF=\"$cgi?board=$board&page=$npage\">$label{'HEADDER_NEXT_PAGE'}</A>\n";
	}
	$html .= "&nbsp; ";

	$html .= "</TD></TR></TABLE><BR>\n";

}

1;
