

#---------------------------
# FINISH MESSAGE

sub FinishMessage {
	my($num) = @_;
	my($ok);
	my($buf,$sys_pass,$sys_rank);
	&GetData( $num );

	$ok = 0;

	if ( $pwd ne '' && $pwd eq $admin_password ){
		$ok = 1;
	} elsif ( $pwd ne '' && $password ne '' && crypt($pwd, 'NICOLE Board') eq $password ){
		$ok = 1;
	} elsif ( $name ne $admin_name ) {
		$buf = &SysopCheck($sysop_id);
		($sys_pass,$sys_rank) = split(/:/,$buf);
		if ( $buf ne '' && $pwd eq $sys_pass && $sys_rank =~ /f/ ) {
			$ok = 1;
		}
	}

	if ( 1 == $ok ) {
		&GetData( $num );
		$flag_fin = 1;
		&SetData( $num );

		require './writedata.pl';
		&WriteData;
		$config{'information'} = "<CENTER><EM>$label{'END_FINISH'}</EM></CENTER>";
		require './view.pl';
		&View($COOKIE{'disp'});
	} else {
		if ( $flag_fin == 1 ) {
			&DrawHeader("$label{'ERROR_HEADDER'}",1,1);
			$html .= "<center><P>$label{'ERROR_END'}</P></center><P><P>\n";
			return;
		} else {
			&DrawHeader("$label{'END_HEADDER'}",1,1);
			if ($password eq ''){
				$html .= "<EM>$label{'END_CAUTION_NOPASS'}</EM><P>\n";
			} elsif (0 != $reply_count ) {
				$html .= "<EM>$label{'END_CAUTION'}</EM><P>\n";
			}
		}

		$html .= "$label{'END_INFO1'}<P>";
		$html .= "$label{'END_INFO2'}";
		$html .= "<P>";
		$html .= "<TABLE BORDER=0><TR>";
		$html .= "<TD><FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=hidden NAME=cmd VALUE=fin>";
		$html .= "<INPUT TYPE=hidden NAME=wparam VALUE='$num'>";
		$html .= "$label{'PASSWORD'} <INPUT TYPE=password NAME=pwd SIZE=10> ";
		$html .= "$label{'SYSOP'} <INPUT TYPE=text NAME=sysop_id SIZE=20> ";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'END_SUBMIT_BUTTON'}\">";
		$html .= "</FORM></TD>";
		$html .= "<TD><FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'END_CANCEL_BUTTON'}\">";
		$html .= "</FORM></TD>";
		$html .= "</TR></TABLE>";

		require './drawtopic.pl';
		&DrawTopic( $num );
	}
}

#---------------------------
# Revive MESSAGE

sub ReviveMessage {
	my($num) = @_;
	my($ok);
	&GetData( $num );

	$ok = 0;

	if ( $config{'fin_mode'} != 1 ) {
		&DrawHeader("$label{'ERROR_HEADDER'}",1,1);
		$html .= "<center><P>$label{'ERROR_REVIVE_SETTING'}</P></center><P><P>\n";
		return;
	}

	if ( $pwd ne '' && $pwd eq $admin_password ){
		$ok = 1;
	} else {
		$buf = &SysopCheck($sysop_id);
		($sys_pass,$sys_rank) = split(/:/,$buf);
		if ( $buf ne '' && $pwd eq $sys_pass && $sys_rank =~ /f/ ) {
			$ok = 1;
		}
	}

	if ( 1 == $ok ) {
		&GetData( $num );
		$flag_fin = 0;
		&SetData( $num );

		require './writedata.pl';
		&WriteData;
		$config{'information'} = "<CENTER><EM>$label{'REVIVE_FINISH'}</EM></CENTER>";
		require './view.pl';
		&View($COOKIE{'disp'});
	} else {
		if ( $flag_fin == 0 ) {
			&DrawHeader("$label{'ERROR_HEADDER'}",1,1);
			$html .= "<center><P>$label{'ERROR_REVIVE'}</P></center><P><P>\n";
			return;
		} else {
			&DrawHeader("$label{'REVIVE_HEADDER'}",1,1);
			if ( $config{'fin_mode'} == 1 ){
				$html .= "<EM>$label{'REVIVE_CAUTION'}</EM><P>\n";
			}
		}

		$html .= "$label{'REVIVE_INFO1'}<P>";
		$html .= "$label{'REVIVE_INFO2'}";
		$html .= "<P>";
		$html .= "<TABLE BORDER=0><TR>";
		$html .= "<TD><FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=hidden NAME=cmd VALUE=revive>";
		$html .= "<INPUT TYPE=hidden NAME=wparam VALUE='$num'>";
		$html .= "$label{'PASSWORD'} <INPUT TYPE=password NAME=pwd SIZE=10> ";
		$html .= "$label{'SYSOP'} <INPUT TYPE=text NAME=sysop_id SIZE=20> ";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'REVIVE_SUBMIT_BUTTON'}\">";
		$html .= "</FORM></TD>";
		$html .= "<TD><FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'REVIVE_CANCEL_BUTTON'}\">";
		$html .= "</FORM></TD>";
		$html .= "</TR></TABLE>";

		require './drawtopic.pl';
		&DrawTopic( $num );
	}
}

1;
