

#---------------------------
# DRAW HEADER

sub	DrawHeader {
	my($title, $show_information, $show_toolbar)=@_;
	my($str, $info, $sr);
	my($sel, $sel2, $font_tbl, $font_cmt);
	my($dummy, $col, $loopcnt);
	my($aname, $num, $n, $reply_no, $sameflag);

	$html = "";
	$loopcnt = 0;

	unless ($title && $title ne ''){
		$title = "$config{'bbstitle'}";
	}

	if ( 1 == $show_information ){
		$info = '';
	} else {
		$info = "<FONT SIZE=2>$config{'information'}</FONT><BR>";
	}

	if (1 == $config{'readonly'} ){
		$sr = "<DIV ALIGN=right><FONT SIZE=2>READONLY</FONT></DIV>\n";
	}

	require './user_agent.pl';
	my($platform, $platform_v, $browser, $browser_v) = &User_Agent($ENV{'HTTP_USER_AGENT'});

	$font_tbl = $font_size;
	$font_cmt = $font_comment_size;
	if ( $browser eq "InternetExplorer" ) {
		$font_tbl = $font_size;
		$font_cmt = $font_comment_size;
	} elsif ( $browser eq "NetscapeNavigator" ) {
		if ( $browser_v =~ "4.7" ) {
			$font_tbl = $nsfont_size47;
			$font_cmt = $nsfont_comment_size47;
		} else {
			$font_tbl = $nsfont_size;
			$font_cmt = $nsfont_comment_size;
		}
	}

	$html .= "<HTML><HEAD>";
	$html .= "<META NAME='GENERATOR' CONTENT='NICOLE Board.cgi v$version Revision $revision'>";
	$html .= "<META HTTP-EQUIV='pragma' CONTENT='no-cache'>";
	$html .= "<META HTTP-EQUIV='Content-Type' CONTENT='text/html; charset=$code'>";
	$html .= "<STYLE>";
	$html .= "A:link { text-decoration: none; color: $config{'color_link'}; }";
	$html .= "A:visited { text-decoration: none; color: $config{'color_link'}; }";
	$html .= "A:active { text-decoration: none; color: $config{'color_em'}; }";
	$html .= "A:hover { text-decoration: underline; color: $config{'color_em'}; }";
	$html .= "BODY { font-size:$font_cmt; scrollbar-base-color:$config{'scroll_base'}; scrollbar-arrow-color:$config{'scroll_arrow'}; }";
	$html .= "EM { text-decoration:none; font-style: normal; font-weight: bold; color: $config{'color_em'}; }";
	$html .= "TABLE.sub { width: 100%; border: thin solid $config{'color_subject_bg'}; background-color:$config{'color_subject'}; }";
	$html .= "TABLE.subT { width: 100%; color:$config{'color_subject'}; background-color:$config{'color_subject_bg'}; }";
	$html .= "TABLE.bgc { width: 100%; background-color:$config{'color_bg'}; }";
	$html .= "TD.fin { color:$config{'color_fin_fc'}; background-color:$config{'color_fin_bc'}; font-size: $font_cmt; }";
	$html .= "TD.fin A:link,TD.fin A:visited { color:$config{'color_fin_fc'}; }";
	$html .= "TD.sub { color:$config{'color_subject'}; background-color:$config{'color_subject_bg'}; }";
	$html .= "TD.cmt { color:$config{'color_comment_text'}; background-color:$config{'color_comment_bg'}; font-size: $font_cmt; }";
	$html .= "TD.cmttxt { background-color:$config{'color_comment_bg'}; font-size: $font_cmt; }";
	$html .= "TD.cmttxt A:link,TD.cmttxt A:visited { color:$config{'color_text'}; }";
	$html .= "TD.cmtlnk { background-color:$config{'color_comment_bg'}; font-size: $font_cmt; }";
	$html .= "TD.cmtlnk A:link,TD.cmtlnk A:visited { color:$config{'color_link'}; }";
	$html .= "FONT.lnk { color:$config{'color_link'}; font-size:$font_cmt; }";
	$html .= "FONT.grn { color:$config{'color_grn_fc'}; font-size:$font_cmt; }";
	$html .= "FONT.adm { color:$config{'color_admin_fc'}; font-size:$font_cmt; }";
	$html .= "FONT.sysop { color:$config{'color_sysop_fc'}; font-size:$font_cmt; }";
	$html .= "FONT.uid { color:$config{'color_uid_fc'}; font-size:$font_cmt; }";

	foreach (@menu_col_array) {
		($dummy,$col) = split(/:/);
		$html .= "TD.menu".$loopcnt." { color:$config{'color_subject'}; background-color: $col; }";
		$loopcnt++;
	}

	$html .= "INPUT { font-size: $font_cmt; }";
	$html .= "OPTION { font-size: $font_cmt; }";
	$html .= "</STYLE>";
	$html .= "<TITLE>$config{'bbstitle'}</TITLE>";
	$html .= "</HEAD>";
	$html .= "<BODY TEXT=$config{'color_text'} BGCOLOR=$config{'color_bg'} LINK=$config{'color_link'} ALINK=$config{'color_link'} VLINK=$config{'color_link'} BACKGROUND='$config{'image_background'}'>";
	$html .= "<BR><TABLE width='100%' class='subT'><TR><TD class='sub'><CENTER><B>";
	$html .= "$title";
	$html .= "</B></CENTER></TD></TR></TABLE>";
	$html .= "$sr";
	$html .= "$str<BR>";
	$html .= "$info";
	$html .= "<BR>";

	if ( 1 != $show_toolbar && 1 != $config{'readonly'} ){
		$html .= "<CENTER>";
		$html .= "<TABLE BORDER=0 CELLPADDING=4 CELLSPACING=0>";
		$html .= "<TR>";
		$html .= "<TD>";
		$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=hidden NAME=cmd VALUE=new>";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_POST_BUTTON'}\">";
		$html .= "</FORM>";
		$html .= "</TD>";
		if ( $config{'show_topiclist'} == 1 ) {
			$html .= "<TD NOWRAP>";
			$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
			$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
			if ( $COOKIE{'disp'} eq '0' ) {
				$html .= "<INPUT TYPE=hidden NAME=cmd VALUE='disp1'>";
				$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_CHANGE_TITLE'}\">";
			} else {
				$html .= "<INPUT TYPE=hidden NAME=cmd VALUE='disp0'>";
				$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_CHANGE_THEREAD'}\">";
			}
			$html .= "</FORM>";
			$html .= "</TD>";
		}

		if ( &IsSort ) {
			$html .= "<TD NOWRAP>";
			$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
			$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
			$html .= "<INPUT TYPE=hidden NAME=cmd VALUE='sort0'>";
			$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_SORT_POST'}\">";
			$html .= "</FORM>";
			$html .= "</TD>";
		} else {
			$html .= "<TD NOWRAP>";
			$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
			$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
			$html .= "<INPUT TYPE=hidden NAME=cmd VALUE='sort1'>";
			$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_SORT_RESPONSE'}\">";
			$html .= "</FORM>";
			$html .= "</TD>";
		}
		
		$html .= "<TD NOWRAP>";

		$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
		$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
		$html .= "<INPUT TYPE=hidden NAME=cmd VALUE=search>";
		$html .= "<INPUT TYPE=text NAME=wparam SIZE=20>";
		$html .= "<INPUT TYPE=submit VALUE=\"$label{'HEADDER_SEARCH'}\">";
		$html .= "</FORM>";
		$html .= "</TD>";
		$html .= "</TR>";


		if ( $config{'menu_use'} == 1 ) {
			$html .= "<TR><TD colspan=4 align='center'>";
			$html .= "<FORM METHOD='$method' ACTION='$cgi_path$cgi'>";
			$html .= "<INPUT TYPE=hidden NAME=board VALUE='$board'>";
			$html .= "<INPUT TYPE=hidden NAME=cmd VALUE=search>";
			&IsKind;
			$html .= "$label{'HEADDER_KIND1'}<select name=kindselect>";
			if ( $kindmenu eq "S" ) { $sel = "selected"; } else { $sel = ""; }
			$html .= "<OPTION VALUE='S' $sel>$label{'HEADDER_KIND1_ALL'}";
			if ( $kindmenu eq "IȊO" ) { $sel = "selected"; } else { $sel = ""; }
			$html .= "<OPTION VALUE='IȊO' $sel>$label{'HEADDER_KIND1_NOEND'}";
			foreach (@menuitems) {
				if ( $kindmenu eq $_ ) { $sel = "selected"; } else { $sel = ""; }
				$html .= "<OPTION VALUE='$_' $sel>$_";
			}
			if ( $kindmenu eq "I" ) { $sel = "selected"; } else { $sel = ""; }
			$html .= "<OPTION VALUE='I' $sel>$label{'HEADDER_KIND1_END'}";
			$html .= "</select>&nbsp;&nbsp;";

			&IsFin;
			$html .= "$label{'HEADDER_KIND2'}";
			$html .= "<select name=finselect>";
			$sel = "";
			$sel2 = "";
			if ( $fincheck ne "on" ) { $sel = "selected"; } else { $sel2 = "selected"; }
			$html .= "<option value='off' $sel>$label{'HEADDER_KIND2_NODISP'}";
			$html .= "<option value='on' $sel2>$label{'HEADDER_KIND2_DISPLAY'}";
			$html .= "</select>";
			$html .= "&nbsp;&nbsp;<INPUT TYPE=submit VALUE=\"$label{'HEADDER_FOCUS_BUTTON'}\">";
			$html .= "</FORM>";
			$html .= "</TD>";
			$html .= "</TR>";
		}

		if ( $easy_info == 1 ) {
			if ( $INFO_COOKIE{'last'} ne '' ) {
				&GetData( $INFO_COOKIE{'last'} );
				if ( $reply_count > $INFO_COOKIE{'reply'} ) {
					$num = $number;
					$aname = $name;
					$reply_no = $reply_count;
					$loopcnt = @replylist;
					for($n=0; $n<$loopcnt; $n++){
						&GetData( $replylist[$n] );
						if ($num == $reply && $number != 0) {
							if ( $aname eq $name ) { $sameflag = 1; } else { $sameflag = 0; }
						}
					}
					if ( $sameflag == 0 ) {
						$html .= "<TR><TD colspan=4 align='center'>";
						$html .= "<A HREF='$cgi_path$cgi?board=$board&cmd=last&wparam=$num&lparam=$reply_no'>";
						if ( $easy_gif eq '' ) {
							$html .= "$label{'HEADDER_INCOMMING'}";
						} else {
							$html .= "<IMG SRC='$easy_gif' BORDER=0 ALT=\"$label{'HEADDER_INCOMMING'}\">"
						}
						$html .= "</A></TD></TR>";
					}
				}
			}
		}
		$html .= "</TABLE>";
		$html .= "</CENTER>";
	}
}

#---------------------------
# DRAW FOOTER

sub DrawFooter {
	my($show_footer) = @_;

	$html .= "<HR NOSHADE SIZE=1>";
	#$html .= "<FONT SIZE=2>";
	$html .= "<TABLE width=100% BORDER=0 CELLPADDING=2 CELLSPACING=0>";
	$html .= "<TR>";
	$html .= "<TD NOWRAP><FONT SIZE=2>";
	$html .= "<A HREF='$cgi_path$cgi?board=$board&cmd='>$label{'FOOTER_ARTICLE'}</A> | ";

	if ( 1 == $showBoardList ) {
		$html .= "<A HREF='$cgi_path$cgi?board'>$label{'FOOTER_BOARD'}</A> | ";
	}

	$html .= "<A HREF='$config{'homepage'}'>$label{'FOOTER_HOMEPAGE'}</A> | ";
	$html .= "<A HREF='admin.cgi'>$label{'FOOTER_ADMINPAGE'}</A>";

	if ( $FORM{'board'} && 1 == $config{'readonly'} && 1 != $show_footer){
		$html .= " | <A HREF='$cgi_path$cgi?board=$board&cmd=new'>$label{'FOOTER_POST'}</A>";
	}

	$html .= "</FONT></TD><TD NOWRAP ALIGN=right><FONT SIZE=2>";
	$html .= "$label{'ADMIN_LABEL'} <A HREF='mailto:$admin_email'><B>$admin_name</B></A></FONT>";
	$html .= "</TD>";
	$html .= "</TR>";
	$html .= "</TABLE>";
	$html .= "<HR NOSHADE SIZE=1>";
	$html .= "<CENTER>$copyright</CENTER>";
	$html .= "</BODY></HTML>";

	if ($gzip_mode == 1 && $ENV{'HTTP_ACCEPT_ENCODING'} =~ /gzip/ ) {
		print "Content-type: text/html; charset=$code\n";
		print "Content-encoding: gzip\n\n";
		open(STDOUT,"| $gzip_position -1 -c");
	} else {
		print "Content-type: text/html; charset=$code\n\n";
	}

	print $html;
}

1;
