

#---------------------------
# SELECT BOARD

sub SelectBoard {
	my($board_count, $board);

	&DrawHeader("$label{'SELECT_HEADDER'}",1,1);

	opendir ( DATADIR, "$dat_dir/");
	@b = readdir(DATADIR);
	closedir (DATADIR);
	@boards = grep(/.cfg/, @b);
	@boards = sort( @boards );
	$board_count = 0;

	foreach(@boards){
		$board_count++;
	}
	$html .= "<B>$board_count</B> $label{'SELECT_INFO'}";
	$html .= "<P>";
	$html .= "<TABLE BORDER=0 CELLPADDING=5 CELLSPACING=1>";
	$html .= "<TR BGCOLOR=#000050>";
	$html .= "<TD><FONT SIZE=2 COLOR=#FFFFFF><B>$label{'SELECT_BOARD'}</B></TD>";
	$html .= "<TD NOWRAP><FONT SIZE=2 COLOR=#ffffff><B>$label{'SELECT_UPDATE'}</B></TD>";
	$html .= "<TD NOWRAP><FONT SIZE=2 COLOR=#ffffff><B>$label{'SELECT_TITLE'}</B></TD>";
	$html .= "<TD NOWRAP><FONT SIZE=2 COLOR=#ffffff><B>$label{'SELECT_POST'}</B></TD>";
	$html .= "<TD NOWRAP><FONT SIZE=2 COLOR=#ffffff><B>$label{'SELECT_NO'}</B></TD>";
	$html .= "</TR>";

	foreach(@boards){
		$board = $_;
		$board =~ s/.cfg//ig;
		$file_data = "$dat_dir/$board.log";
		require './getconfig.pl';
		&ReadConfig("$dat_dir/$board.cfg");

		if ( 0 != open(FILE,"$file_data") ){
			$number = '';
			$name = '';
			$atime = '';
			$reply = '';
			$subject = '';
			while(<FILE>) {
				chop;
				($number,$reply,$reply_count,$reply_time,$time,$subject,$name,$email,$hp,$icq,$ip,$password,$comment,$menu,$remote_host,$flag_fin,$uid) = split(/<>/);
				$atime = &FormatDateTime( $time, 1 );
				last;
			}
			close(FILE);
		}
		$name = &FormatName($name);
		if ($subject eq '' && 0 != $reply ){ $subject = "No.$reply$label{'SELECT_REPLY'}";}
		$html .= "<TR BGCOLOR=#f0f0f0>";
		$html .= "<TD><B><A HREF='$cgi_path$cgi?board=$board'>$config{'bbstitle'}</A></B></TD>";
		$html .= "<TD NOWRAP><FONT SIZE=2>$atime</TD>";
		$html .= "<TD><FONT SIZE=2>$subject</TD>";
		$html .= "<TD><FONT SIZE=2>$name</TD>";
		$html .= "<TD ALIGN=right><FONT SIZE=2>$number</TD>";
		$html .= "</TR>";
	}
	$html .= "</TABLE>\n";
	&DrawFooter(0);
}

1;
